/**
 * core.js - all global scripts belong in this file.
 */

// NAMESPACE FOR COMMON FUNCTIONS/OBJECTS
var COMMONUTILS = {
    //
    pageWidth : function () {"use strict";
        return document.documentElement.clientWidth;
    },

    // OBJ TO HOLD USERS CURRENT WEBPAGE LOCATION
    currentPage : window.location.pathname.substring (window.location.pathname.lastIndexOf ('/') + 1),

    // FUNCTION TO EXECUTE CODE BASED ON LOCATION
    userLocation : function (pagename) {"use strict";
        var page = pagename;
        $ ('#nav a').removeClass ('active');
        switch(page) {
            case 'index':
                $ ('#nav-home').addClass ('active');
                break;
            case 'about':
                $ ('#nav-about').addClass ('active');
                break;
            case 'cast':
                $ ('#nav-cast').addClass ('active');
                break;
            case 'news':
                $ ('#nav-news').addClass ('active');
                break;
            case 'reviews':
                $ ('#nav-reviews').addClass ('active');
                break;
            case 'tickets':
                $ ('#nav-tickets').addClass ('active');
                break;
            case 'gallery':
                $ ('#nav-gallery').addClass ('active');
                break;
            case 'privacy':
                $ ('#nav a').removeClass ('active');
                break;
            default:
                // No Case
                $ ('#nav-home').addClass ('active');
        }
    },

    optinFormValidate: function() {
    	"use strict";

      var formName = "";

      $(".subscribe").each(function(i){

      	//console.log(i);
      	formName = "optin"+i;
      	$(this).attr("id",formName);

          //
          $(this).validate({
            rules : {
              email : { required : true, email : true }/*,
              zip : 'required'*/
            },
            messages : {
              email : 'Enter a valid email'/*,
              zip : 'Enter your zip code'*/
            },
            errorPlacement : function(error, element) {
              element.attr('placeholder', error[0].outerText);
            },
            submitHandler : function(form) {
              $.ajax({
                url : './_inc/optin_action.php',
                type : 'POST',
                data : $(form).serialize() + '&ajax=true',
                success : function() {
                  $(form).hide();
                  $(form).parent("div").append('<h3 class="text-center form-thanks">THANK YOU FOR <br class="visible-xs" />SIGNING UP.<br /><span>Check your email to <br class="visible-xs" />confirm your subscription.</span></h3>');
                }
              });
              return false;
            }
          });

      });
    },

    nav: function() {
    	"use strict";

    	$("#btn-menu").on("click",function(e){
      	e.preventDefault();
      	if( $("#nav").hasClass("open") ){
        	$("#nav, #btn-menu").removeClass("open");
        	$("#btn-menu").removeClass("fa-times-thin").addClass("fa-bars");
      	} else {
        	$("#nav, #btn-menu").addClass("open");
        	$("#btn-menu").addClass("fa-times-thin").removeClass("fa-bars");
      	}
    	});

    	$("#icon-envelope").click(function(){
      	$("html").addClass("modal-open");
    	});

    },

    video: function() {
    	"use strict";

    	/*$(".video-link").each(function(e){
      	  if( $(this).data("thumb") != "" ){
        	  $(this).html('<div class="video-thumb"><img src="'+ $(this).data("thumb") +'" class="w100"></div>');
      	  } else {
        	  $(this).html('<div class="video-thumb"><img src="http://img.youtube.com/vi/'+ $(this).data("id") +'/hqdefault.jpg" class="w100"></div>');
      	  }
      	  if( $(this).data("caption") != "" ){
      	    //console.log('yo');
        	  $(this).append("<div class='video-caption'>"+$(this).data("caption")+"</div>");
      	  }
    	});*/

    	$(document).on("click",".video-link",function(e){
    	    e.preventDefault();
    	    if( $("#video-overlay-close").length == 0 ){
      	    $("#video-overlay").append('<a id="video-overlay-close"></a>');
    	    }
        	$("#video-overlay-inner").html('<iframe src="https://www.youtube.com/embed/'+ $(this).data("id") +'?rel=0&modestbranding=1&autohide=1&showinfo=0&autoplay=1" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>');
        	$("html").addClass("video-overlay-open");
    	});

    	$(document).on("click","#video-overlay-close, #video-overlay",function(e){
    	    e.preventDefault();
        	$("#video-overlay-inner").html('');
        	$("html").removeClass("video-overlay-open");
    	});

    },

    quotes: function() {
    	"use strict";
      $('#quotes').quote_rotator();

    }
};

//Namespace for bio functions
var bioGrid = {};

// Close Cast Overlay
bioGrid.hideOverlay = function () {
    $ (".overlay-close").click (function (e) {
        e.preventDefault ();
        $ ("html").removeClass ("overlay-open");
        $ (".overlay").removeClass ("open");
    });
};


// jQuery Namespace
$ (document).ready (function () {"use strict";
    $('html').addClass('page-loaded');
    COMMONUTILS.optinFormValidate();
    $('.nyt-quote').quote_rotator();
    $('#quotes-rotate').quote_rotator();

    //Bios
    $('#creative-bios').load('./creative.html',function(){
      setTimeout(loadOverlays,200);
      setTimeout(overlayClick,300);
      /*$('#creative-bios').load('./creative.html',function(){
        setTimeout(loadOverlays,200);
        setTimeout(overlayClick,300);
      });*/
    });

    bioGrid.hideOverlay();

    //Overlay content
    var castOverlay = [];
    function loadOverlays() {
      $('.team-member').each(function(index){
        $(this).addClass("actor-" + (index+1));
        var cloneBio = $(this).clone();
        castOverlay.push(cloneBio);
      });
    }

    function overlayClick() {
      $(document).on('click','.team-member',function () {
         var bioClasses = $(this).attr('class');
         var characters = bioClasses.length;
         var loc;
         if (characters == 30) {
           loc = (bioClasses.slice(-1) - 1);
         } else if (characters == 31) {
           loc = (bioClasses.slice(-2) - 1);
         }
         var bioContent = castOverlay[loc];
         populateOverlay(bioContent,loc);
         bioNav(loc);
       });


    }

    function populateOverlay(bio,locNum) {
      //add overlay
      $("#overlay-inner").fadeOut(10, function() {
        $(this).html(castOverlay[locNum]).fadeIn(500);
      });
      $("html").addClass ("overlay-open");
      $(".overlay").addClass("open").focus();
      console.log(locNum);
      if(locNum === 0) {
        $('.overlay-prev').hide();
      } else if (locNum === 2/*34*/) {
        $('.overlay-next').hide();
      } else {
        $('.overlay-next').show();
        $('.overlay-prev').show();
      }

    }

    //Next/Previous navigation
    function bioNav(bioNum) {
      console.log(bioNum);
      $(".overlay-next").click(function(e) {
        e.preventDefault();
        $(".overlay-prev").show();
        console.log(bioNum);
        if (bioNum == 17) {
          $(this).hide();
        } else {
          $(this).show();
        }
        bioNum = bioNum + 1;
        $("#overlay-inner").fadeOut(300, function() {
          $(this).html(castOverlay[bioNum]).fadeIn(500);
        });
        arrowFix();
      });

      $(".overlay-prev").click(function(e) {
        e.preventDefault();
        $(".overlay-next").show();
        if (bioNum == 1) {
          $(this).hide();
        }
        else {
          $(this).show();
        }
        bioNum = bioNum - 1;
        $("#overlay-inner").fadeOut(300, function() {
          $(this).html(castOverlay[bioNum]).fadeIn(500);
        });
      });
    }

    function arrowFix() {
      if($('#overlay-inner .team-member').hasClass('actor-2')) {
        $('.overlay-next').hide();
      }
    }

      var pgWidth = document.documentElement.clientWidth;
      var pgHeight = $(window).height();

      function imageHeight() {
        var secHeight = $('.logo img').height();
        $('.parallax').height(secHeight - 5);
        //$('.white-left').height(secHeight - 5);
        //$('.white-right').height(secHeight - 5);
      }

      function whitePos() {
        var offDis = $(".logo").offset();
        var leftDis = offDis.left;
        $('.white-left').width(leftDis);
        $('.white-right').width(leftDis);
      }

      function paraTop() {
        var quoHeight = $('.top-stuff').height();
        var posTop;
        if (pgWidth > 767) {
          posTop = (quoHeight - 0) + "px";
          $( "<style>div.parallax:after { top:-" + posTop + "; }</style>" ).appendTo( "head" );
        }
        if (pgHeight > 1000) {
          console.log('yep');
          posTop = (quoHeight + 150) + "px";
          $( "<style>div.parallax:after { top:-" + posTop + "; }</style>" ).appendTo( "head" );
        }
      }

      function snipeCenter() {
        if (pgWidth <= 767) {
          var fullWidth = $('#header').width();
          var snipeWidth = fullWidth - 130;
          $('#snipe').width(snipeWidth);
        }
      }

      paraTop();
      //setTimeout(imageHeight, 100);
      //setTimeout(whitePos, 100);
      //snipeCenter();


      $( window ).resize(function() {
          //imageHeight();
          paraTop();
          //whitePos();
          //snipeCenter();
          var pgWidth = document.documentElement.clientWidth;
          var pgHeight = $(window).height();
      });

      //Scroll Effects
      /*var controller = new ScrollMagic.Controller();

      var leftSecQuo = new ScrollMagic.Scene({
        triggerElement: "#quote-trigger-left"
      })
    		.setClassToggle("#quotes-rotate", "show")
    		.addIndicators({name: "1 - left - add a class"}) // add indicators (requires plugin)
    		.addTo(controller);

      var rightQuo = new ScrollMagic.Scene({triggerElement: "#quote-trigger-left"})
      		.setClassToggle(".right", "show")
      		.addIndicators({name: "2 - right - add a class"}) // add indicators (requires plugin)
      		.addTo(controller);

    var tixSec = new ScrollMagic.Scene({triggerElement: "#tix-trigger"})
          .setClassToggle("#tickets-section", "show")
          .addTo(controller);

      var aboutSec = new ScrollMagic.Scene({triggerElement: "#about-trigger"})
          .setClassToggle("#about-section", "show")
          .addTo(controller);

      var castSec = new ScrollMagic.Scene({triggerElement: "#cast-trigger"})
          .setClassToggle("#cast-section", "show")
          .addTo(controller);


        if( pgWidth > 767) {
          leftSecQuo.triggerHook(0.5);
        } else {
          leftSecQuo.triggerHook(1);
        }*/


        //PAGE FADE IN
        function pgFade() {
          $('#outerwrapper').addClass('fade-in');
        }

        setTimeout(pgFade, 110);


        //GALLERY
        $('#gallery').slick({
          //slidesToShow: 3,
          //slidesToScroll: 1,
          //dots: true,
          centerMode: false,
          focusOnSelect: true,
          prevArrow: $('.prev'),
          nextArrow: $('.next'),
              dots: false,
              infinite: true,
              speed: 300,
              slidesToShow: 3,
              slidesToScroll: 1,
              responsive: [
                {
                  breakpoint: 600,
                  settings: {
                    slidesToShow: 1,
                    slidesToScroll: 1
                  }
                }
              ]
        });

        $('#gallery').slickLightbox({
          src: 'src',
          itemSelector: '.item img',
          slick: {
            prevArrow: '<button type="button" class="slick-prev"><i class="fas fa-chevron-left"></i></button>',
            nextArrow: '<button type="button" class="slick-next"><i class="fas fa-chevron-right"></i></button>'
          }
        });




    //Location Dropdown

    /*if (pgWidth <= 767) {
      $(".top-level" ).click(function(e) {
        e.preventDefault();
        if($('.dropdown').hasClass('active')) {
          $(".dropdown").removeClass('active');
        } else {
          $(".dropdown").addClass('active');
        }

      })


    } else {
      $("#location-nav" ).mouseover(function() {
        $(".dropdown").addClass('active');
      })
      .mouseout(function() {
        $(".dropdown").removeClass('active');
      });

    }*/

    //Awards Height
    /*function winHeight() {
      var txtHeight = $('blockquote.tony').height();
      var finalHeight = txtHeight;
      console.log(finalHeight);
      $('.win-img').height(finalHeight);
    }

    winHeight();

    $( window ).resize(function() {
        winHeight();
    });*/



});

// EOF
